var BuffModel = require("./BuffModel");

var debuffOptionsArray = {};

var init = function (heroData, unitData) {
    debuffOptionsArray.items = [
        new BuffModel(heroData, unitData, 'abaddon', 'abaddon_frostmourne'),
        new BuffModel(heroData, unitData, 'alchemist', 'alchemist_acid_spray'),
        new BuffModel(heroData, unitData, 'ancient_apparition', 'ancient_apparition_ice_vortex'),
        new BuffModel(heroData, unitData, 'axe', 'axe_battle_hunger'),
        new BuffModel(heroData, unitData, 'bane', 'bane_enfeeble'),
        new BuffModel(heroData, unitData, 'batrider', 'batrider_sticky_napalm'),
        new BuffModel(heroData, unitData, 'beastmaster', 'beastmaster_primal_roar'),
        new BuffModel(heroData, unitData, 'bounty_hunter', 'bounty_hunter_jinada'),
        new BuffModel(heroData, unitData, 'brewmaster', 'brewmaster_thunder_clap'),
        new BuffModel(heroData, unitData, 'brewmaster', 'brewmaster_drunken_haze'),
        new BuffModel(heroData, unitData, 'bristleback', 'bristleback_viscous_nasal_goo'),
        new BuffModel(heroData, unitData, 'broodmother', 'broodmother_incapacitating_bite'),
        new BuffModel(heroData, unitData, 'centaur', 'centaur_stampede'),
        new BuffModel(heroData, unitData, 'chen', 'chen_penitence'),
        new BuffModel(heroData, unitData, 'crystal_maiden', 'crystal_maiden_crystal_nova'),
        new BuffModel(heroData, unitData, 'crystal_maiden', 'crystal_maiden_freezing_field'),
        new BuffModel(heroData, unitData, 'dazzle', 'dazzle_weave'),
        new BuffModel(heroData, unitData, 'drow_ranger', 'drow_ranger_frost_arrows'),
        new BuffModel(heroData, unitData, 'earth_spirit', 'earth_spirit_rolling_boulder'),
        new BuffModel(heroData, unitData, 'elder_titan', 'elder_titan_natural_order'),
        new BuffModel(heroData, unitData, 'elder_titan', 'elder_titan_earth_splitter'),
        new BuffModel(heroData, unitData, 'enchantress', 'enchantress_untouchable'),
        new BuffModel(heroData, unitData, 'enchantress', 'enchantress_enchant'),
        new BuffModel(heroData, unitData, 'faceless_void', 'faceless_void_time_walk'),
        new BuffModel(heroData, unitData, 'huskar', 'huskar_life_break'),
        new BuffModel(heroData, unitData, 'invoker', 'invoker_ghost_walk'),
        new BuffModel(heroData, unitData, 'invoker', 'invoker_ice_wall'),
        new BuffModel(heroData, unitData, 'wisp', 'wisp_tether'),
        new BuffModel(heroData, unitData, 'jakiro', 'jakiro_dual_breath'),
        new BuffModel(heroData, unitData, 'jakiro', 'jakiro_liquid_fire'),
        new BuffModel(heroData, unitData, 'keeper_of_the_light', 'keeper_of_the_light_blinding_light'),
        new BuffModel(heroData, unitData, 'kunkka', 'kunkka_torrent'),
        new BuffModel(heroData, unitData, 'lich', 'lich_frost_nova'),
        new BuffModel(heroData, unitData, 'lich', 'lich_frost_armor'),
        new BuffModel(heroData, unitData, 'lich', 'lich_chain_frost'),
        new BuffModel(heroData, unitData, 'life_stealer', 'life_stealer_open_wounds'),
        new BuffModel(heroData, unitData, 'lion', 'lion_voodoo'),
        new BuffModel(heroData, unitData, 'magnataur', 'magnataur_skewer'),
        new BuffModel(heroData, unitData, 'medusa', 'medusa_stone_gaze'),
        new BuffModel(heroData, unitData, 'meepo', 'meepo_geostrike'),
        new BuffModel(heroData, unitData, 'naga_siren', 'naga_siren_rip_tide'),
        new BuffModel(heroData, unitData, 'night_stalker', 'night_stalker_void'),
        new BuffModel(heroData, unitData, 'night_stalker', 'night_stalker_crippling_fear'),
        new BuffModel(heroData, unitData, 'night_stalker', 'night_stalker_darkness'),
        new BuffModel(heroData, unitData, 'ogre_magi', 'ogre_magi_ignite'),
        new BuffModel(heroData, unitData, 'omniknight', 'omniknight_degen_aura'),
        new BuffModel(heroData, unitData, 'phantom_assassin', 'phantom_assassin_stifling_dagger'),
        new BuffModel(heroData, unitData, 'phantom_lancer', 'phantom_lancer_spirit_lance'),
        new BuffModel(heroData, unitData, 'pudge', 'pudge_rot'),
        new BuffModel(heroData, unitData, 'pugna', 'pugna_decrepify'),
        new BuffModel(heroData, unitData, 'queenofpain', 'queenofpain_shadow_strike'),
        new BuffModel(heroData, unitData, 'riki', 'riki_smoke_screen'),
        new BuffModel(heroData, unitData, 'rubick', 'rubick_fade_bolt'),
        new BuffModel(heroData, unitData, 'sand_king', 'sandking_epicenter'),
        new BuffModel(heroData, unitData, 'nevermore', 'nevermore_dark_lord'),
        new BuffModel(heroData, unitData, 'shadow_shaman', 'shadow_shaman_voodoo'),
        new BuffModel(heroData, unitData, 'skeleton_king', 'skeleton_king_hellfire_blast'),
        new BuffModel(heroData, unitData, 'skeleton_king', 'skeleton_king_reincarnation'),
        new BuffModel(heroData, unitData, 'skywrath_mage', 'skywrath_mage_concussive_shot'),
        new BuffModel(heroData, unitData, 'skywrath_mage', 'skywrath_mage_ancient_seal'),
        new BuffModel(heroData, unitData, 'slardar', 'slardar_slithereen_crush'),
        new BuffModel(heroData, unitData, 'slardar', 'slardar_amplify_damage'),
        new BuffModel(heroData, unitData, 'slark', 'slark_essence_shift'),
        new BuffModel(heroData, unitData, 'sniper', 'sniper_shrapnel'),
        new BuffModel(heroData, unitData, 'spectre', 'spectre_spectral_dagger'),
        new BuffModel(heroData, unitData, 'storm_spirit', 'storm_spirit_overload'),
        new BuffModel(heroData, unitData, 'templar_assassin', 'templar_assassin_meld'),
        new BuffModel(heroData, unitData, 'tidehunter', 'tidehunter_gush'),
        new BuffModel(heroData, unitData, 'tinker', 'tinker_laser'),
        new BuffModel(heroData, unitData, 'treant', 'treant_leech_seed'),
        new BuffModel(heroData, unitData, 'tusk', 'tusk_frozen_sigil'),
        new BuffModel(heroData, unitData, 'undying', 'undying_flesh_golem'),
        new BuffModel(heroData, unitData, 'ursa', 'ursa_earthshock'),
        new BuffModel(heroData, unitData, 'vengefulspirit', 'vengefulspirit_wave_of_terror'),
        new BuffModel(heroData, unitData, 'vengefulspirit', 'vengefulspirit_command_aura'),
        new BuffModel(heroData, unitData, 'venomancer', 'venomancer_venomous_gale'),
        new BuffModel(heroData, unitData, 'venomancer', 'venomancer_poison_sting'),
        new BuffModel(heroData, unitData, 'viper', 'viper_poison_attack'),
        new BuffModel(heroData, unitData, 'viper', 'viper_corrosive_skin'),
        new BuffModel(heroData, unitData, 'viper', 'viper_viper_strike'),
        new BuffModel(heroData, unitData, 'visage', 'visage_grave_chill'),
        new BuffModel(heroData, unitData, 'warlock', 'warlock_upheaval'),
        new BuffModel(heroData, unitData, 'weaver', 'weaver_the_swarm'),
        new BuffModel(heroData, unitData, 'windrunner', 'windrunner_windrun'),
        new BuffModel(heroData, unitData, 'winter_wyvern', 'winter_wyvern_arctic_burn'),
        new BuffModel(heroData, unitData, 'winter_wyvern', 'winter_wyvern_splinter_blast'),
        new BuffModel(heroData, unitData, 'npc_dota_neutral_ghost', 'ghost_frost_attack'),
        new BuffModel(heroData, unitData, 'npc_dota_neutral_polar_furbolg_ursa_warrior', 'polar_furbolg_ursa_warrior_thunder_clap'),
        new BuffModel(heroData, unitData, 'npc_dota_neutral_ogre_magi', 'ogre_magi_frost_armor'),
        new BuffModel(heroData, unitData, 'npc_dota_neutral_satyr_trickster', 'satyr_trickster_purge'),
        new BuffModel(heroData, unitData, 'npc_dota_neutral_enraged_wildkin', 'enraged_wildkin_tornado')
    ];
    return debuffOptionsArray.items;
}

debuffOptionsArray.init = init;

module.exports = debuffOptionsArray;